-- Hangul Chatting Mod for Supreme Commander: Forged Alliance by Joongi Kim.

--do
	-- Setup dependency
	--local UIUtil = import('/lua/ui/uiutil.lua')
	--local LayoutHelpers = import('/lua/maui/layouthelpers.lua')	
	--local Text = import('/lua/maui/text.lua').Text
	--local Group = import('/lua/maui/group.lua').Group
	local hangul_mod = import('/mods/hangulchat/hangul.lua')
	local lazyvar_mod = import('/lua/lazyvar.lua')

	-- Initialize
	local old_CreateChatEdit = CreateChatEdit
	local old_CreateChatBackground = CreateChatBackground
	local preview = nil

	LOG('loading hangulchat for in-game chatting...')

	function CreateChatBackground()
		local bg = old_CreateChatBackground()

		-- Create a preview edit box
		LOG('initializing UI of hangulchat...')
		preview = Edit(bg)
		preview.Depth:Set(bg.Depth() - 1)
		preview.Left:Set(function() return bg.Left() end)
		preview.Top:Set(function() return bg.Bottom() + 5 end)
		preview.Right:Set(function() return bg.Right() end)
		preview.Bottom:Set(function() return bg.Bottom() + 28 end)
		UIUtil.SetupEditStd(preview, "ffcccccc", nil, "ffffffff", UIUtil.highlightColor, UIUtil.bodyFont, 14, 200)
		preview:SetText('(preview of input text)')

		return bg
	end

	function CreateChatEdit()
		local group = old_CreateChatEdit()

		-- Hook the related events of the edit control
		LOG('hooking events for hangulchat...')
		local old_OnEnterPressed = group.edit.OnEnterPressed
		group.edit.OnEnterPressed = function(self, text)
			old_OnEnterPressed(self, hangul_mod.conv2hangul(text))
		end
		group.edit.OnTextChanged = function(self, newText, oldText)
			if preview ~= nil then preview:SetText(hangul_mod.conv2hangul(newText)) end
		end

		return group
	end
--end
